/* Copyright (c) 2003 methodic[@libpcap.net], All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "orbs.h"

void get_telnet_banner(int sockfd, char *host, int port, char *raw_banner) {

	int i=0, j=0, x=0, y=0, len=0;
	char buf[LEN];
	unsigned char tmpbuf[LEN], *p, obuf[4];

	/* copy our raw buffer into an unsigned char buffer */
	strcpy(tmpbuf, (unsigned char *)raw_banner);
	len = strlen(tmpbuf);

	do {
		for(i = 0; i < len; i++) {
			/* we need to check every 3rd response, ie 0, 3, 6, 9, etc */
			if((i % 3) == 0 && i > 0) {
#ifdef DEBUG
				debug("recv(%3u, %3u, %3u) [num=%2d] [seq=%2d]", tmpbuf[i-3], tmpbuf[i-2], tmpbuf[i-1], ++j, i);
#endif
				if(tmpbuf[i-3] != 255) { /* not a telnet IAC */
					i=0;
					for(j = 0; j < len; j++) {
#ifdef DEBUG
						printf("%u,", tmpbuf[j]);
#endif
						/* skip any telnet commands we still may have in
						 * the buffer */
						if(tmpbuf[j] == 255) {
							j++; j++;
						} else if(tmpbuf[j] != 0 && tmpbuf[j] != 13) {
							/* make sure we have enough memory */
							if(i < LEN) {
								buf[i] = tmpbuf[j];
								i++;
							}
						}
					}
					buf[i] = '\0';
					output_handler(host, port, buf);
					return;
				}
			}
		}

		/* if we recieved a telnet command, respond to it */
		/* most of code ripped from netcat */
		p = tmpbuf;
		x = strlen(tmpbuf);
		while(x > 0) {
			obuf[0] = 255;
			p++; x--;
			if( (*p == 251) || (*p == 252) )
				y = 254;
			if( (*p == 253) || (*p == 254) )
				y = 252;
			if(y) {
				obuf[1] = y;
				p++; x--;
				obuf[2] = *p;
				send(sockfd, obuf, 3, 0);
				y = 0;
			}
			p++; x--;
		}

		bzero(tmpbuf, LEN);
		len = recv(sockfd, tmpbuf, (LEN-1), 0);

	}while(p != NULL);

}
