/* Copyright (c) 2003 methodic[@libpcap.net], All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

/* defines */
#define RELMAJOR 1
#define RELMINOR 1

#define FALSE 0
#define TRUE 1

#define LEN 512
#define IPLEN 16

#define STDOUT 0
#define TEXT 1
#define HTML 2

/* function prototypes */
void usage(char *prog);
void debug(char *msg, ...);
void fatal(char *msg, ...);
void cleanup(void);
void parse_ports(char *ports);
void parse_hosts(char *arg);
void hosts_from_file(char *filename);
void scan_host(char *host);
void output_handler(char *host, int port, char *raw_banner);
void catch_signal();
void get_telnet_banner(int sockfd, char *host, int port, char *raw_banner);
char *parse_banner(char *raw_banner);
void do_port_hook(int port, int sockfd);
