/* Copyright (c) 2003 methodic[@libpcap.net], All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "orbs.h"

char *parse_banner(char *raw_banner) {

	char *banner, *ptr, *p;

	banner = (char *)malloc(sizeof(char) * LEN);
	bzero(banner, LEN);

	/* ftp or smtp banner */
	if(strncmp(raw_banner, "220 ", 4) == 0 && strlen(raw_banner) > 4) {
		memmove(banner, (raw_banner+4), strlen(raw_banner)-4);
	}

	/* http banner */
	ptr = strstr(raw_banner, "Server: ");
	if( ptr != NULL) {
		/* search for the next newline char */
		p = strchr(ptr, '\n');
		/* make sure we even have something to parse.. */
		if(strlen(ptr) > 8 && p != NULL) {
			/* move past "Server: " */
			ptr += 8;
			/* copy the length of ptr minus p minus 1 */
			if((strlen(ptr) - strlen(p) - 1) > 0) {
				memmove(banner, ptr, (strlen(ptr) - strlen(p)-1));
			}
		}
	}
		
	/* pop3 banner */
	if(strncmp(raw_banner, "+OK ", 4) == 0 && strlen(raw_banner) > 4) {
		memmove(banner, (raw_banner+4), strlen(raw_banner)-4);
	}

	/* imap banner */
	if(strncmp(raw_banner, "* OK ", 5) == 0 && strlen(raw_banner) > 5) {
		memmove(banner, (raw_banner+5), strlen(raw_banner)-5);
	}

	/* sanity check. make sure there is something to return */
	if(strlen(banner) > 0) {
		return(banner);
	} else {
		return(raw_banner);
	}

}
