/* Copyright (c) 2003 methodic[@libpcap.net], All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <regex.h>
#include "orbs.h"

/* recipe taken from mothra w/ modification */
#define IP_RANGE "([1-9][0-9]?|1[0-9][0-9]|2[0-5][0-5])|[-*]"

void parse_hosts(char *arg) {

	unsigned int i=0, j=0, k=0, l=0;
	unsigned int start_addr[4]={0, 0, 0, 0}, end_addr[4]={0, 0, 0, 0};
	char *dot=NULL, *dash=NULL, host[IPLEN];
	regex_t reg;

	/* regex check for an ip range */
	regcomp(&reg, IP_RANGE, REG_EXTENDED);

	if(regexec(&reg, arg, (size_t) 0, NULL, 0) == REG_NOMATCH) {
#ifdef DEBUG
		debug("host: %s", arg);
#endif
		scan_host(arg);
	} else {
		/* parse the host argument into one or more ip's */
		dot = strtok(arg, ".");
		if(dot != NULL) {
			do {
				dash = strchr(dot, '-');
				if(dash != NULL) {
					/* we found a dash, which means we have a range of hosts */
					dot[strlen(dot) - strlen(dash)] = '\0';
					start_addr[i] = atoi(dot);
					dash++;
					end_addr[i] = atoi(dash);
				} else {
					/* check for an asterik */
					if(*dot == '*') {
						start_addr[i] = 1;
						end_addr[i] = 254;
					} else {
						start_addr[i] = atoi(dot);
						end_addr[i] = atoi(dot);
					}
				}
				i++;
				dot = strtok(NULL, ".");
			}while(dot != NULL);
		}
#ifdef DEBUG
		debug("start addr: %d.%d.%d.%d", start_addr[0], start_addr[1], start_addr[2], start_addr[3]);
		debug("end addr: %d.%d.%d.%d", end_addr[0], end_addr[1], end_addr[2], end_addr[3]);
#endif
		/* i know this is cheesy, but it works. */
		for(i = start_addr[0]; i <= end_addr[0]; i++) {
			for(j = start_addr[1]; j <= end_addr[1]; j++) {
				for(k = start_addr[2]; k <= end_addr[2]; k++) {
					for(l = start_addr[3]; l <= end_addr[3]; l++) {
						bzero(host, IPLEN);
						snprintf(host, IPLEN, "%d.%d.%d.%d", i, j, k, l);
#ifdef DEBUG
						debug("host: %s", host);
#endif
						scan_host(host);
					}
				}
			}
		}

	}
	regfree(&reg);

}
