/* Copyright (c) 2003 methodic[@libpcap.net], All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

#include <stdio.h>
#include <stdlib.h>

void usage(char *prog) {

	printf("USAGE: %s [OPTIONS] <host argument(s)>\n", prog);
	printf("OPTIONS:\n");
	printf("-p\tports to scan (-p 21,25,80-110)\n");
	printf("-v\tverbose output\n");
	printf("-a\toutput all info, not just banners grabbed\n");
	printf("-t\ttimeout in seconds (default=5)\n");
	printf("-r\tfile to read hosts from (newline seperated)\n");
	printf("-R\tprint out the raw banner, default is to parse\n");
	printf("-o\tfile to log output to\n");
	printf("-f\toutput format (t=text, h=html)\n");
	printf("\ntypical uses:\n");
	printf("  %s -p 21,23,25 localhost\n", prog);
	printf("  %s -p 1-19,80 -o out.html -f h host1 host2 host3\n", prog);
	printf("  %s -p 1080,8080 -R -r host_list.txt\n", prog);
	printf("\nadditional valid host arguments: 192.168.1.1-254 10.1-10.*.*\n");
	exit(0);

}
